SystemOrganization addCategory: #'PVpub-AnalogClockPrototype05'!

CircleMorph subclass: #Dial05
	instanceVariableNames: 'boundsLag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype05'!

!Dial05 methodsFor: 'drawing' stamp: 'pv 12/2/2013 20:26'!
drawOn: aCanvas 
	| currentExtent oldExtent |
	currentExtent := self bounds corner - self bounds origin.
	oldExtent := boundsLag corner - boundsLag origin.
	currentExtent ~= oldExtent
		ifTrue: [self submorphs
				do: [:each | each isMovingWatchhand
						ifTrue: [each step]].
			boundsLag := self bounds].
	super drawOn: aCanvas! !

!Dial05 methodsFor: 'initialization' stamp: 'pv 12/1/2013 00:26'!
initialize
	super initialize.
	self extent: 200 @ 200;
		 position: 300 @ 300;
		 layoutPolicy: ConcentricLayout new.
	boundsLag := 1 @ 1 corner: 2 @ 2.
	self pvtInitializeResizableWatchhand! !

!Dial05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:35'!
pvtInitializeResizableWatchhand
	| watchHand05 |
	watchHand05 :=  ResizableWatchHand05 new.
	watchHand05 setDial: self.
	watchHand05
		setInitialMidnightVerticesFromCenter: self center
		andRadius: self extent x / 2
		withFraction: 0.9! !

PolygonMorph subclass: #ResizableWatchHand05
	instanceVariableNames: 'watchHand04m watchHand04 midnightVertices dial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype05'!

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:32'!
addMidnightWatchhandFrom: anArray
	watchHand04m setMidnightVerticesFrom: anArray.
	watchHand04m setVertices: anArray;
		 visible: false.
	dial
		addMorph: watchHand04m
		fullFrame: (LayoutConcentricFrame
				left: 0.3
				right: 0.3
				top: 0.9
				bottom: 0.3)! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/1/2013 00:24'!
addRotatingWatchhand
	watchHand04
		setInitialMidnightVerticesFromCenter: dial center
		andRadius: dial extent x / 2
		withFraction: 0.9.
	dial addMorph: watchHand04! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:52'!
initialize
	super initialize.
	watchHand04m := WatchHand05 new.
	watchHand04 := WatchHand05 new.
	watchHand04 setMidnightWatchhand: watchHand04m! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:30'!
setDial: aDial 
	dial := aDial! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/1/2013 00:28'!
setInitialMidnightVerticesFromCenter: aPoint andRadius: aFloat withFraction: aFractionFloat 
	"2013-09-29pv: vertices sind immer Float"
	| lozengeLengthFromCenter lozengeWidthFromCenter a |
	lozengeLengthFromCenter := 3 max: aFloat * aFractionFloat.
	lozengeWidthFromCenter := 1 max: aFloat * (aFractionFloat / 3).
	a := Array
				with: aPoint + (0 @ lozengeWidthFromCenter)
				with: aPoint + (-1 * lozengeWidthFromCenter @ 0)
				with: aPoint + (0 @ -1 * lozengeLengthFromCenter)
				with: aPoint + (lozengeWidthFromCenter @ 0).
				self addMidnightWatchhandFrom: a.

	self addRotatingWatchhand! !

PolygonMorph subclass: #WatchHand05
	instanceVariableNames: 'midnightWatchhand midnightVertices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype05'!

!WatchHand05 class methodsFor: 'geometry' stamp: 'pv 12/2/2013 20:19'!
inDegrees: aTime 
	"080413 should be a class method."
	| timeValue delta |
	delta := 0.0.
	timeValue := (aTime perform: #seconds) asFloat.
	^ 360 * timeValue / 60! !

!WatchHand05 methodsFor: 'accessing - properties' stamp: 'pv 12/2/2013 20:16'!
isMovingWatchhand
	self layoutFrame
		ifNil: [^ true].
	^ false! !

!WatchHand05 methodsFor: 'geometry' stamp: 'pv 12/2/2013 20:15'!
rotationDegreesFromMidnightPosition: degrees 
	| flex center |
	(center := self valueOfProperty: #referencePosition)
		ifNil: [self setProperty: #referencePosition toValue: (center := self bounds center)].
	flex := (MorphicTransform offset: center negated)
				withAngle: degrees degreesToRadians.
	self
		setVertices: (vertices
				collect: [:v | (flex transform: v)
						- flex offset]).
	self forwardDirection: degrees! !

!WatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:17'!
setInitialMidnightVerticesFromCenter: aPoint andRadius: aFloat withFraction: aFractionFloat 
	"2013-09-29pv: vertices sind immer Float"
	| lozengeLengthFromCenter lozengeWidthFromCenter |
	lozengeLengthFromCenter := 3 max: aFloat * aFractionFloat.
	lozengeWidthFromCenter := 1 max: aFloat * (aFractionFloat / 3).
	midnightVertices := Array
				with: aPoint + (0 @ lozengeWidthFromCenter)
				with: aPoint + (-1 * lozengeWidthFromCenter @ 0)
				with: aPoint + (0 @ -1 * lozengeLengthFromCenter)
				with: aPoint + (lozengeWidthFromCenter @ 0).
	self setVertices: midnightVertices! !

!WatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:17'!
setMidnightVerticesFrom: anArray 
	midnightVertices := anArray! !

!WatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:17'!
setMidnightWatchhand: aWatchHand 
	midnightWatchhand := aWatchHand! !

!WatchHand05 methodsFor: 'stepping and presenter' stamp: 'pv 12/2/2013 20:15'!
step
	self isMovingWatchhand
		ifFalse: [^ self].
	midnightWatchhand
		ifNil: [^ self].
	vertices := midnightWatchhand vertices.
	self setRotationCenterFrom: owner center.
	self
		rotationDegreesFromMidnightPosition: (self class inDegrees: DateAndTime now)! !

!WatchHand05 methodsFor: 'stepping and presenter' stamp: 'pv 12/2/2013 20:15'!
stepTime
	^ 1000! !
